package com.mot.tests;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

import org.apache.log4j.Logger;
import org.jboss.soa.esb.actions.AbstractActionPipelineProcessor;
import org.jboss.soa.esb.actions.ActionProcessingException;
import org.jboss.soa.esb.actions.soap.SOAPClient;
import org.jboss.soa.esb.helpers.ConfigTree;
import org.jboss.soa.esb.message.Body;
import org.jboss.soa.esb.message.Message;

public class TestSOAPAction extends AbstractActionPipelineProcessor
{
    protected ConfigTree _config;
    private static final Logger logger = Logger.getLogger(TestSOAPAction.class);

    public TestSOAPAction(ConfigTree config)
    {
	_config = config;
    }

    @Override
    public Message process(Message message) throws ActionProcessingException
    {
	logger.info("Service invoked");
	doSOAPRequest1(message);
	logger.info("finished calling doSOAPRequest1");
	return null;
    }

    private void doSOAPRequest1(org.jboss.soa.esb.message.Message message)
    {
	logger.info("entry processing doSOAPRequest1");
	try
	{

	    String soapRequestBody = getStringFromFile("D:\\redltvxml\\test\\ISCDHCP\\test.xml");
	    logger.info("input request :" + soapRequestBody);
	    // msg.getBody().add("RequestLocation", inputRequest);
	    Map<String, String> soapParams = new HashMap<String, String>();
	    soapParams.put("addSubscriberAccountXML.String_1", soapRequestBody);
	    logger.info("soap params :" + soapParams);
	    message.getBody().add("RequestLocation", soapParams);

	    // just safe side
	    message.getBody().add(soapParams.toString());
	    makeSOAPCall(message);

	}
	catch (Exception e)
	{
	    e.printStackTrace();
	}
	finally
	{
	    logger.info("finished processing doSOAPRequest1");
	}

    }

    public static void makeSOAPCall(org.jboss.soa.esb.message.Message message)
    {
	try
	{

	    System.out.println(System.getProperty("java.home"));

	    String httpprops = getStringFromFile("D:\\redltvxml\\test\\ISCDHCP\\http-client-8443.xml");
	    ConfigTree newCT = ConfigTree.fromXml(httpprops, "UTF-8");
	    newCT.setName("config");
	    logger.info("newCT config of soap client :" + newCT.toString());
	    Message msg = null;
	    String responseBody;
	    SOAPClient soapClient = null;

	    try
	    {
		soapClient = new SOAPClient(newCT);
		soapClient.initialise();
		msg = soapClient.process(message);
		responseBody = (String) msg.getBody().get(Body.DEFAULT_LOCATION);
		logger.info(" SOAP Response of soapClient :" + responseBody);

		// logger.info(" message after soap invocation :\n" + message.getBody().toString());

	    }
	    catch (Exception e)
	    {
		logger.error("SOAP Response of soapClient :" + e.getMessage(), e);

	    }
	    finally
	    {
		if (null != soapClient)
		    soapClient.destroy();
	    }

	}

	catch (Exception e)
	{
	    logger.error(e.getMessage(), e);
	}

    }

    static String getStringFromFile(String fileName)
    {
	System.out.println(new File(fileName).getAbsolutePath());
	BufferedReader bf;
	StringBuffer sprXML = new StringBuffer();
	try
	{
	    bf = new BufferedReader(new FileReader(fileName));

	    String line = null;

	    while ((line = bf.readLine()) != null)
	    {
		sprXML.append(line);
	    }
	}
	catch (FileNotFoundException e1)
	{

	    e1.printStackTrace();
	}
	catch (IOException e)
	{

	    e.printStackTrace();
	}

	// String escapedString = StringEscapeUtils.escapeXml(sprXML.toString());
	return sprXML.toString();
    }

    @Override
    public void processException(org.jboss.soa.esb.message.Message message, Throwable t)
    {
	logger.error("Unhandled exception occured while processing msg", t);
    }

}
